.nolist
include \masm32\include\masm32rt.inc
.686
include \masm32\macros\timers.asm
	LOOP_COUNT	= 100000
	RepCt		textequ <1000>

EXTERNDEF _imp__GetTickCount@0:PTR pr0
EXTERNDEF _imp__PostMessageA@16:PTR pr4
EXTERNDEF _imp__GetDesktopWindow@0:PTR pr0


.data?
hWin	dd ?

.code
start:
	invoke GetDesktopWindow
	mov hWin, eax
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT RepCt
		   invoke GetTickCount
		ENDM
	counter_end
	% print str$(eax), 9, "cycles for &RepCt&*GetTickCount, indirect", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT RepCt
		  invoke _imp__GetTickCount@0
		ENDM
	counter_end
	% print str$(eax), 9, "cycles for &RepCt&*GetTickCount, direct", 13, 10


	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT RepCt
		   invoke GetDesktopWindow
		ENDM
	counter_end
	% print str$(eax), 9, "cycles for &RepCt&*GetDesktopWindow, indirect", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		REPEAT RepCt
		  invoke _imp__GetDesktopWindow@0
		ENDM
	counter_end
	% print str$(eax), 9, "cycles for &RepCt&*GetDesktopWindow, direct", 13, 10

	REPEAT 1
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		invoke PostMessage, hWin, WM_NULL, 0, 0
	counter_end
	print str$(eax), 9, "cycles for PostMessage, indirect", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		invoke _imp__PostMessageA@16, hWin, WM_NULL, 0, 0
	counter_end
	print str$(eax), 9, "cycles for PostMessage, direct", 13, 10
	ENDM
	inkey chr$(13, 10, "--- ok ---", 13)
	exit
end start

RichMasm options:

OPT_Tmp2Asm	1
OPT_Wait	0
